import gleam/dynamic/decode.{type Decoder}
import gleam/option.{type Option}
import utils/decode as decode_utils

pub type Account {
  Account(
    id: String,
    email: Option(String),
    token: Option(String),
    created_at: String,
  )
}

pub fn decoder() -> Decoder(Account) {
  use id <- decode.field("id", decode.string)
  use email <- decode_utils.field_value_optional("email", decode.string)
  use token <- decode_utils.field_key_value_optional("token", decode.string)
  use created_at <- decode.field("createdAt", decode.string)
  decode.success(Account(id:, email:, token:, created_at:))
}
