import gleam/dynamic/decode.{type Decoder}
import utils/decode as decode_utils

pub type ActivityLevel {
  Weak
  Growing
  Strong
  Restricted
}

pub fn to_string(activity_level: ActivityLevel) -> String {
  case activity_level {
    Weak -> "WEAK"
    Growing -> "GROWING"
    Strong -> "STRONG"
    Restricted -> "RESTRICTED"
  }
}

pub fn parse(activity_level_str: String) -> Result(ActivityLevel, ActivityLevel) {
  case activity_level_str {
    "WEAK" -> Ok(Weak)
    "GROWING" -> Ok(Growing)
    "STRONG" -> Ok(Strong)
    "RESTRICTED" -> Ok(Restricted)
    _ -> Error(Weak)
  }
}

pub fn decoder() -> Decoder(ActivityLevel) {
  decode_utils.enum_decoder(parse, "ActivityLevel")
}
