import gleam/dynamic/decode.{type Decoder}
import models/agent_symbol.{type AgentSymbol}

pub type Agent {
  Agent(
    account_id: String,
    symbol: AgentSymbol,
    headquarters: String,
    credits: Int,
    starting_faction: String,
    ship_count: Int,
  )
}

pub fn decoder() -> Decoder(Agent) {
  use account_id <- decode.field("accountId", decode.string)
  use symbol <- decode.field("symbol", agent_symbol.decoder())
  use headquarters <- decode.field("headquarters", decode.string)
  use credits <- decode.field("credits", decode.int)
  use starting_faction <- decode.field("startingFaction", decode.string)
  use ship_count <- decode.field("shipCount", decode.int)
  decode.success(Agent(
    account_id:,
    symbol:,
    headquarters:,
    credits:,
    starting_faction:,
    ship_count:,
  ))
}
