import gleam/dynamic/decode.{type Decoder}
import models/ship_symbol.{type ShipSymbol}
import models/waypoint_symbol.{type WaypointSymbol}

pub type ChartTransaction {
  ChartTransaction(
    waypoint_symbol: WaypointSymbol,
    ship_symbol: ShipSymbol,
    total_price: Int,
    timestamp: String,
  )
}

pub fn decoder() -> Decoder(ChartTransaction) {
  use waypoint_symbol <- decode.field(
    "waypointSymbol",
    waypoint_symbol.decoder(),
  )
  use ship_symbol <- decode.field("shipSymbol", ship_symbol.decoder())
  use total_price <- decode.field("totalPrice", decode.int)
  use timestamp <- decode.field("timestamp", decode.string)
  decode.success(ChartTransaction(
    waypoint_symbol:,
    ship_symbol:,
    total_price:,
    timestamp:,
  ))
}
