import gleam/dynamic/decode.{type Decoder}
import models/construction_material.{type ConstructionMaterial}

pub type Construction {
  Construction(
    symbol: String,
    materials: List(ConstructionMaterial),
    is_complete: Bool,
  )
}

pub fn decoder() -> Decoder(Construction) {
  use symbol <- decode.field("symbol", decode.string)
  use materials <- decode.field(
    "materials",
    decode.list(construction_material.decoder()),
  )
  use is_complete <- decode.field("isComplete", decode.bool)
  decode.success(Construction(symbol:, materials:, is_complete:))
}
