import gleam/dynamic/decode.{type Decoder}
import utils/decode as decode_utils

pub type CrewRotation {
  Strict
  Relaxed
}

pub fn to_string(crew_rotation: CrewRotation) -> String {
  case crew_rotation {
    Strict -> "STRICT"
    Relaxed -> "RELAXED"
  }
}

pub fn parse(crew_rotation_str: String) -> Result(CrewRotation, CrewRotation) {
  case crew_rotation_str {
    "STRICT" -> Ok(Strict)
    "RELAXED" -> Ok(Relaxed)
    _ -> Error(Strict)
  }
}

pub fn decoder() -> Decoder(CrewRotation) {
  decode_utils.enum_decoder(parse, "CrewRotation")
}
