import gleam/dynamic/decode.{type Decoder}
import utils/decode as decode_utils

pub type EngineSymbol {
  EngineImpulseDriveI
  EngineIonDriveI
  EngineIonDriveII
  EngineHyperDriveI
}

pub fn to_string(engine_symbol: EngineSymbol) -> String {
  case engine_symbol {
    EngineImpulseDriveI -> "ENGINE_IMPULSE_DRIVE_I"
    EngineIonDriveI -> "ENGINE_ION_DRIVE_I"
    EngineIonDriveII -> "ENGINE_ION_DRIVE_II"
    EngineHyperDriveI -> "ENGINE_HYPER_DRIVE_I"
  }
}

pub fn parse(engine_symbol_str: String) -> Result(EngineSymbol, EngineSymbol) {
  case engine_symbol_str {
    "ENGINE_IMPULSE_DRIVE_I" -> Ok(EngineImpulseDriveI)
    "ENGINE_ION_DRIVE_I" -> Ok(EngineIonDriveI)
    "ENGINE_ION_DRIVE_II" -> Ok(EngineIonDriveII)
    "ENGINE_HYPER_DRIVE_I" -> Ok(EngineHyperDriveI)
    _ -> Error(EngineImpulseDriveI)
  }
}

pub fn decoder() -> Decoder(EngineSymbol) {
  decode_utils.enum_decoder(parse, "EngineSymbol")
}
