import gleam/dynamic/decode.{type Decoder}
import utils/decode as decode_utils

pub type ShipNavFlightMode {
  Drift
  Stealth
  Cruise
  Burn
}

pub fn to_string(ship_nav_flight_mode: ShipNavFlightMode) -> String {
  case ship_nav_flight_mode {
    Drift -> "DRIFT"
    Stealth -> "STEALTH"
    Cruise -> "CRUISE"
    Burn -> "BURN"
  }
}

pub fn parse(
  ship_nav_flight_mode_str: String,
) -> Result(ShipNavFlightMode, ShipNavFlightMode) {
  case ship_nav_flight_mode_str {
    "DRIFT" -> Ok(Drift)
    "STEALTH" -> Ok(Stealth)
    "CRUISE" -> Ok(Cruise)
    "BURN" -> Ok(Burn)
    _ -> Error(Drift)
  }
}

pub fn decoder() -> Decoder(ShipNavFlightMode) {
  decode_utils.enum_decoder(parse, "ShipNavFlightMode")
}
