import gleam/dynamic/decode.{type Decoder}
import utils/decode as decode_utils

pub type ShipRole {
  Fabricator
  Harvester
  Hauler
  Interceptor
  Excavator
  Transport
  Repair
  Surveyor
  Command
  Carrier
  Patrol
  Satellite
  Explorer
  Refinery
}

pub fn to_string(ship_role: ShipRole) -> String {
  case ship_role {
    Fabricator -> "FABRICATOR"
    Harvester -> "HARVESTER"
    Hauler -> "HAULER"
    Interceptor -> "INTERCEPTOR"
    Excavator -> "EXCAVATOR"
    Transport -> "TRANSPORT"
    Repair -> "REPAIR"
    Surveyor -> "SURVEYOR"
    Command -> "COMMAND"
    Carrier -> "CARRIER"
    Patrol -> "PATROL"
    Satellite -> "SATELLITE"
    Explorer -> "EXPLORER"
    Refinery -> "REFINERY"
  }
}

pub fn parse(ship_role_str: String) -> Result(ShipRole, ShipRole) {
  case ship_role_str {
    "FABRICATOR" -> Ok(Fabricator)
    "HARVESTER" -> Ok(Harvester)
    "HAULER" -> Ok(Hauler)
    "INTERCEPTOR" -> Ok(Interceptor)
    "EXCAVATOR" -> Ok(Excavator)
    "TRANSPORT" -> Ok(Transport)
    "REPAIR" -> Ok(Repair)
    "SURVEYOR" -> Ok(Surveyor)
    "COMMAND" -> Ok(Command)
    "CARRIER" -> Ok(Carrier)
    "PATROL" -> Ok(Patrol)
    "SATELLITE" -> Ok(Satellite)
    "EXPLORER" -> Ok(Explorer)
    "REFINERY" -> Ok(Refinery)
    _ -> Error(Fabricator)
  }
}

pub fn decoder() -> Decoder(ShipRole) {
  decode_utils.enum_decoder(parse, "ShipRole")
}
