import gleam/dynamic/decode.{type Decoder}
import utils/decode as decode_utils

pub type SupplyLevel {
  Scarce
  Limited
  Moderate
  High
  Abundant
}

pub fn to_string(supply_level: SupplyLevel) -> String {
  case supply_level {
    Scarce -> "SCARCE"
    Limited -> "LIMITED"
    Moderate -> "MODERATE"
    High -> "HIGH"
    Abundant -> "ABUNDANT"
  }
}

pub fn parse(supply_level_str: String) -> Result(SupplyLevel, SupplyLevel) {
  case supply_level_str {
    "SCARCE" -> Ok(Scarce)
    "LIMITED" -> Ok(Limited)
    "MODERATE" -> Ok(Moderate)
    "HIGH" -> Ok(High)
    "ABUNDANT" -> Ok(Abundant)
    _ -> Error(Scarce)
  }
}

pub fn decoder() -> Decoder(SupplyLevel) {
  decode_utils.enum_decoder(parse, "SupplyLevel")
}
