import gleam/dynamic/decode.{type Decoder}
import utils/decode as decode_utils

pub type TransactionType {
  Purchase
  Sell
}

pub fn to_string(transaction_type: TransactionType) -> String {
  case transaction_type {
    Purchase -> "PURCHASE"
    Sell -> "SELL"
  }
}

pub fn parse(
  transaction_type_str: String,
) -> Result(TransactionType, TransactionType) {
  case transaction_type_str {
    "PURCHASE" -> Ok(Purchase)
    "SELL" -> Ok(Sell)
    _ -> Error(Purchase)
  }
}

pub fn decoder() -> Decoder(TransactionType) {
  decode_utils.enum_decoder(parse, "TransactionType")
}
